package com.yijia.system.mapper;

import java.util.List;
import org.apache.ibatis.annotations.Param;
import com.yijia.common.core.domain.entity.SysDept;

/**
 * 部门管理 数据层
 *
 * @author yijia
 */
public interface SysDeptMapper
{
    /**
     * 查询部门管理数据
     *
     * @param dept 部门信息
     * @return 部门信息集合
     */
    public List<SysDept> selectDeptList(SysDept dept);

    /**
     * 根据角色ID查询部门树信息
     *
     * @param roleId 角色ID
     * @param deptCheckStrictly 部门树选择项是否关联显示
     * @return 选中部门列表
     */
    public List<Integer> selectDeptListByRoleId(@Param("roleId") Long roleId, @Param("deptCheckStrictly") boolean deptCheckStrictly);

    /**
     * 根据部门ID查询信息
     *
     * @param deptId 部门ID
     * @return 部门信息
     */
    public SysDept selectDeptById(Long deptId);

    /**
     * 根据ID查询所有子部门
     *
     * @param deptId 部门ID
     * @return 部门列表
     */
    public List<SysDept> selectChildrenDeptById(Long deptId);

    /**
     * 根据ID查询所有子部门（正常状态）
     *
     * @param deptId 部门ID
     * @return 子部门数
     */
    public int selectNormalChildrenDeptById(Long deptId);

    /**
     * 是否存在子节点
     *
     * @param deptId 部门ID
     * @return 结果
     */
    public int hasChildByDeptId(Long deptId);

    /**
     * 查询部门是否存在用户
     *
     * @param deptId 部门ID
     * @return 结果
     */
    public int checkDeptExistUser(Long deptId);

    /**
     * 校验部门名称是否唯一
     *
     * @param deptName 部门名称
     * @param parentId 父部门ID
     * @return 结果
     */
    public SysDept checkDeptNameUnique(@Param("deptName") String deptName, @Param("parentId") Long parentId);

    /**
     * 新增部门信息
     *
     * @param dept 部门信息
     * @return 结果
     */
    public int insertDept(SysDept dept);

    /**
     * 修改部门信息
     *
     * @param dept 部门信息
     * @return 结果
     */
    public int updateDept(SysDept dept);

    /**
     * 修改所在部门的父级部门状态
     *
     * @param dept 部门
     */
    public void updateDeptStatus(SysDept dept);

    /**
     * 修改子元素关系
     *
     * @param depts 子元素
     * @return 结果
     */
    public int updateDeptChildren(@Param("depts") List<SysDept> depts);

    /**
     * 删除部门管理信息
     *
     * @param deptId 部门ID
     * @return 结果
     */
    public int deleteDeptById(Long deptId);

    public List<SysDept> selectDeptListTree(SysDept dept);

    public List<SysDept> queryDeptList(SysDept dept);

    /**
     * 根据对象查询油站信息
     * */
    public SysDept selectDept(SysDept sysDept);
    /**
     * 根据对象查询集团信息
     * */
    public SysDept getGroupInfo(SysDept dept);
    /**
     *  查询分配代理管理
     * @param dept
     * @return
     */
    public  List<SysDept> selectSysAgentList(SysDept dept);

    /**
     * 代理人查询油站信息
     * @param sysDept
     * @return
     */
    public  List<SysDept> selectDeptAgentList(SysDept sysDept);

    /**
     * 根据集团查询油站信息
     * @param sysDept
     * @return
     */
    public List<SysDept> searchDeptList(SysDept sysDept);

    /**
     * 根据集团查询集团及油站信息
     * @param deptId
     * @return
     */
    public List<SysDept> selectGroupAndDeptList(Long deptId);
    /**
     * 查询代理所有的集团
     * @param sysDept
     * @return
     */
    public List<SysDept> selectGroupAgentList(SysDept sysDept);

    /**
     * 查询是否共享的集团
     * @param sysDept
     * @return
     */
    public List<SysDept> selectShareGroup(SysDept sysDept);
    /**
     * 查询是否共享的站点
     * @param sysDept
     * @return
     */
    List<SysDept> selectNotShareDept(SysDept sysDept);
}
